//+------------------------------------------------------------------+
//|                                                       MAonMA.mq4 |
//|                                                 Copyright  2012 |
//|                                             basisforex@gmail.com |
//+------------------------------------------------------------------+
#property copyright "Copyright  2012"
#property link      "basisforex@gmail.com"

#property indicator_chart_window
#property indicator_buffers 3
#property indicator_color1 Blue
#property indicator_color2 Aqua
#property indicator_color3 Yellow
//---- input parameters
extern int    maPeriod_1      = 13;
extern int    maMethod_1      = 0;
extern int    maAppPrice_1    = 0;
extern int    maPeriod_2      = 34;
extern int    maMethod_2      = 0;
extern int    maPeriod_3      = 89;
extern int    maMethod_3      = 0;
extern bool   alertsOn        = true;
extern bool   alertsOnCurrent = true;
extern bool   alertsMessage   = true;
extern bool   alertsSound     = false;
extern bool   alertsNotify    = true;
extern bool   alertsEmail     = true;
extern string soundFile       = "alert2.wav"; 
//---- indicator buffers
double a[]; 
double b[]; 
double c[];
double trend[];
//+------------------------------------------------------------------+
int init()
 {
   IndicatorBuffers(4);
   SetIndexBuffer(0,a);
   SetIndexBuffer(1,b);
   SetIndexBuffer(2,c);
   SetIndexBuffer(3,trend);
   return(0);
 }
//+------------------------------------------------------------------+
int start()
 {
   int i,counted_bars=IndicatorCounted();
      if(counted_bars<0) return(-1);
      if(counted_bars>0) counted_bars--;
           int limit=MathMin(Bars-counted_bars,Bars-1);
 
   //
   //
   //
   //
   //
   
   for (i=limit; i>=0; i--) a[i] = iMA(NULL, 0,   maPeriod_1,0, maMethod_1, maAppPrice_1, i);
   for (i=limit; i>=0; i--) b[i] = iMAOnArray(a,0,maPeriod_2,0, maMethod_2, i);  
   for (i=limit; i>=0; i--)
   {
      c[i] = iMAOnArray(b,0, maPeriod_3, 0, maMethod_3, i);
      trend[i] = trend[i+1];
         if (a[i]>b[i]) trend[i] = 1;
         if (a[i]<b[i]) trend[i] =-1;
    }    
    
    //
    //
    //
    //
    //
      
    if (alertsOn)
    {
      if (alertsOnCurrent)
           int whichBar = 0;
      else     whichBar = 1;
      if (trend[whichBar] != trend[whichBar+1])
      if (trend[whichBar] == 1)
            doAlert("Buy");
      else  doAlert("Sell");       
    }
return(0);
}

//------------------------------------------------------------------
//
//------------------------------------------------------------------
//
//
//
//
//

void doAlert(string doWhat)
{
   static string   previousAlert="nothing";
   static datetime previousTime;
   string message;
   
      if (previousAlert != doWhat || previousTime != Time[0]) {
          previousAlert  = doWhat;
          previousTime   = Time[0];

          //
          //
          //
          //
          //

          message =  StringConcatenate(Symbol()," at ",TimeToStr(TimeLocal(),TIME_SECONDS)," MAonMA ",doWhat);
             if (alertsMessage) Alert(message);
             if (alertsNotify)  SendNotification(StringConcatenate(Symbol(), Period() ," MAonMA " +" "+message));
             if (alertsEmail)   SendMail(StringConcatenate(Symbol()," MAonMA "),message);
             if (alertsSound)   PlaySound(soundFile);
      }
}
      


